clc
clear
close all

Img0_noise = imread('noisy.png');
%Img_noise = imnoise(Img0,'gaussian', 0.0, 0.2);

bits = 8;
Img_noise = double(Img0_noise)/((2^bits)-1);
bits = 1;

[ny, nx, ch]= size(Img_noise);

lam = 0.15;

Img_A=funTV(Img_noise,.99, lam);

figure; 

subplot(3,3,1); imshow(Img_noise/((2^bits)-1)); title('Input')

subplot(3,3,2); imshow(Img_A/((2^bits)-1)); title('Output')

noise_A = abs(Img_noise-Img_A);

subplot(3,3,3); imshow(noise_A/((2^bits)-1)); title('Noise A')

variance_noise = sum(sum((noise_A(:,:,1)./((2^bits)-1)).^2))/(ny*nx*ch);

figure
imshow(Img_noise/((2^bits)-1));
title('Original');
figure
imshow(Img_A./((2^bits)-1));
title('Imagen filtrada');
figure

imwrite(Img_A, 'result.png');